const { Command, flags } = require('@oclif/command')
const {getAll} = require('../services/polls')
const Listr = require('listr')

function findMostVotedAnswer(ctx) {
  const mostVoted = Math.max(...ctx.poll.choices.map(choice => {
    return choice.votes
  }))
  ctx.stdout = {
    mostVoted: mostVoted,
  }
  return Promise.resolve(mostVoted)
}

function getPolls(ctx, number) {
  return Promise.resolve(getAll(number)
  .then(poll => {
    ctx.poll = poll
  }))
}

class SearchCommand extends Command {
  async run() {
    const { flags } = this.parse(SearchCommand)
    const number = flags.number || 10
    const tasks = [
      {
        title: `Searching for poll #${number}`,
        task: ctx => getPolls(ctx, number),
      },
      {
        title: 'Finding most voted answer',
        task: ctx => findMostVotedAnswer(ctx),
      },
    ]
    const listr = new Listr(tasks)
    listr.run()
    .then(ctx => {
      this.log(ctx.stdout)
    })
    .catch(error => {
      this.error(error)
    })
  }
}

SearchCommand.description = `Searches a poll
...
Extra documentation goes here
`

SearchCommand.flags = {
  number: flags.string({ char: 'n', description: 'poll number' }),
}

module.exports = SearchCommand
